function [report exponents factors]=Table4(probs,behData)
    times=zeros(1440,3);
    for j = 1:3
        a=find((behData(:,2)==2).*(mod(behData(:,3),10)==j+2));
        times(:,j)=sum(behData(a,6:7),2);
    end
    probs=reshape(permute(reshape(probs,36,3,40,3),[1,3,4,2]),1440,3,3);
    exponents=zeros(3,6);
    factors=zeros(3,12);
    fullVals=zeros(3,1);
    vals=zeros(4,1);
    for i = 1:3
        exponents(:,i)=fminsearch(@(x)fullFit(times(:,i),probs(:,:,i),x),[0 0 0]);
        [fullVals(i),factors(:,i)]=fullFit(times(:,i),probs(:,:,i),exponents(:,i));
    end
    vals(1)=sum(fullVals);
    exponents(:,4)=fminsearch(@(x)fitSharedExps(times,probs,x),[0 0 0]);
    [vals(2),factors(:,4:6)]=fitSharedExps(times,probs,exponents(:,4));
    exponents(1,5)=fminsearch(@(x)fitExpState1(times,probs,x),0);
    [vals(3),factors(:,7:9)]=fitExpState1(times,probs,exponents(1,5));
    exponents(1,6)=fminsearch(@(x)fitExpState1Factors1(reshape(times,4320,1),probs,x),0);
    [vals(4),temp]=fitExpState1Factors1(reshape(times,4320,1),probs,exponents(1,6));
    factors(:,10)=temp(1:3);
    factors(1,11:12)=temp(4:5);
    report=cat(2,[18,12,10,6]',vals);
    report(:,3)=4320*log(vals/4320)+report(:,1)*log(4320);
end
function [val,newparams] = fullFit(times,probs,exps)
    ncases=length(times)/36;
    stimes=repmat(cat(2,[1:36]'.^exps(1),[1:36]'.^exps(2),[1:36]'.^exps(3)),ncases,1);
    regs=probs.*stimes;
    newparams=regress(times,regs);
    preds=regs*newparams;
    val=sum((preds-times).^2);
end
function [val,newparams] = fitSharedExps(times,probs,exps)
    ncases=size(times,1)/36;
    stimes=repmat(cat(2,[1:36]'.^exps(1),[1:36]'.^exps(2),[1:36]'.^exps(3)),ncases,1);
    newparams=zeros(3,3);
    vals=zeros(3,1);
    for i = 1:3
        regs=probs(:,:,i).*stimes;
        newparams(:,i)=regress(times(:,i),regs);
        preds=regs*newparams(:,i);
        vals(i)=sum((preds-times(:,i)).^2);
    end
    val=sum(vals);
end  
function [val,newparams] = fitExpState1(times,probs,exp)
    ncases=size(times,1)/36;
    stimes=repmat(cat(2,[1:36]'.^exp,ones(36,2)),ncases,1);
    newparams=zeros(3,3);
    vals=zeros(3,1);
    for i = 1:3
        regs=probs(:,:,i).*stimes;
        newparams(:,i)=regress(times(:,i),regs);
        preds=regs*newparams(:,i);
        vals(i)=sum((preds-times(:,i)).^2);
    end
    val=sum(vals);
end 
function [val,factors] = fitExpState1Factors1(times,probs,param)
    temp=[1:36]'.^param;
    regs=zeros(4320,5);
    regs(1:1440,1)=repmat(temp,40,1).*probs(:,1,1);
    regs(1441:2880,2)=repmat(temp,40,1).*probs(:,1,2);
    regs(2881:4320,3)=repmat(temp,40,1).*probs(:,1,3);
    regs(:,4)=reshape(probs(:,2,:),4320,1);
    regs(:,5)=reshape(probs(:,3,:),4320,1);
    factors=regress(times,regs);
    val=sum((regs*factors-times).^2);
end