function [betas,regressors]= analyzebetas(bold,descriptors,probpairs,subjects,good)
    nsubjs=max(subjects);
    nregions=size(bold,2);
    regressors=constructDesign(descriptors(:,1),descriptors(:,2),descriptors(:,3),probpairs);
    betas=zeros(9,nregions,nsubjs);
    for i = 1:nsubjs
        for j = 1:nregions
            a=good(subjects(good)==i);
            betas(:,j,i)=regress(bold(a,j),regressors(a,:));
        end
    end
end
function [regressors,design]=constructDesign(mapping,x,y,probpairs)
    probpairs(:,11)=sum(probpairs(:,9:11),2);
    probpairs(:,[4,6,8,9,10,12])=[];
    ncases=length(x);
    design=zeros(y(end),9);
    design(x,1)=1;
    index=1;
    sums=sum(probpairs,2);
    for i = 1:ncases
        a=find(mapping==i);
        b=find(sums(index:end)<.1,1)-1;
        design(x(a)+1:x(a)+b,2:7)=probpairs(index:index+b-1,:);
        design(x(a)+b+1,8)=1;
        design(x(a)+b+2:y(a),9)=1;
        index=index+b+1;
    end
    g=zeros(15,1);
    for i = 1:15
        %g(i)=(gamcdf(i*2,6,1)-gamcdf(i*2-2,6,1))-(gamcdf(i*2,16,1)-gamcdf(i*2-2,16,1))/6;
        g(i)=(gamcdf(i*2-1,6,1)-gamcdf(i*2-3,6,1))-(gamcdf(i*2-1,16,1)-gamcdf(i*2-3,16,1))/6;
    end
    g=g/sum(g);
    regressors=zeros(y(end)+14,9);
    for i = 1:9
        regressors(:,i)=conv(design(:,i),g);
    end
end
    
    
    

