function [context signal,fullprobs] = contextSignal(factors,means,params,probpairs,problems)
    y=find(factors(:,2)==0);
    x=cat(1,1,y(1:end-1)+1);
    ncases=length(y);
    fullprobs=probpairs(y,[4,8,12]);
    signal=zeros(ncases,3);
    for i = 1:3
        for j = 1:ncases
            signal(j,i)=exp(hsmmOne(factors(x(j):y(j)-1,2:end-1),means(:,1:3),params(i*3-2:i*3,:,problems(j))));
        end
    end
    signal=max(1.0e-10,signal./repmat(sum(signal,2),1,3));
    context=fullprobs./signal;
    context=context./repmat(sum(context,2),1,3);
end
function [lkh B forward] = hsmmOne(factors,means,params)
    nscans=size(factors,1);
    B=zeros(nscans+1,4);
    for i = 1:3
        B(1:end-1,i) = -sum((factors - repmat(means(:,i)',nscans,1)).^2,2)/2; 
    end
    B(1:end-1,1:end-1)=exp(B(1:end-1,1:end-1));
    B(end,:)=[0 0 0 1];
    basesum = sum(B,2);
    B=(B./repmat(basesum,1,4))';
    T=nscans+1;
    bmx=zeros(4,T);
    S=zeros(4,T);
    E=zeros(4,T);
    P=zeros(4,15);
    P=zeros(4,15);
    for i = 1:3
        P(i,:)=gammaCDM(params(i,1),params(i,2),15)';
    end
    P(4,1)=1;
    A = skips([0 1 0 0; 0 0 1 0; 0 0 0 1; 1 0 0 0],params,15);
    ALPHA=repmat(cat(1,A(4,1:3)'/sum(A(4,1:3)),0),1,15).*P;
    r=(B(:,1)'*sum(ALPHA,2));	
    forward(1,:)=B(:,1).*sum(ALPHA,2);
    bmx(:,1)=B(:,1)./r;
    E(:,1)=bmx(:,1).*ALPHA(:,1);
    S(:,1)=A'*E(:,1);
    lkh=log(r);
    P(:,1:15-1);
    for t=2:nscans+1
        ALPHA=[repmat(S(:,t-1),1,15-1).*P(:,1:15-1)+repmat(bmx(:,t-1),1,15-1).*ALPHA(:,2:15),S(:,t-1).*P(:,15)];		%Equation (12)  the future    
        r=(B(:,t)'*sum(ALPHA,2));
        forward(t,:)=B(:,t).*sum(ALPHA,2);
        bmx(:,t)=B(:,t)./r;			
        E(:,t)=bmx(:,t).*ALPHA(:,1);
        S(:,t)=A'*E(:,t);
        lkh=lkh+log(r);
    end
end
