function [A,states] = estimateA(probpairs,conds)
width=size(probpairs,2);
nstates=width/4;
probpairs=probpairs(sum(probpairs(:,[4:4:width]),2)>.5,[4:4:width]);
probpairs=probpairs(conds==1,:);
nsubjs=size(probpairs,1)/108;
probpairs=reshape(probpairs,36,3,nsubjs,nstates);
states=reshape(mean(reshape(probpairs,36,nsubjs*3,nstates),2),36,nstates);
if nstates>1
    params=fminsearch(@(x)stateProb(states,x),repmat(.2,1,nstates-1));
end
A=cat(2,zeros(width,1),cat(1,eye(width-1),zeros(1,width-1)));
for i = 1:nstates-1
    A(i*4,i*4+1)=params(i);
    A(i*4,i*4-3)=(1-params(i));
end
A(width,width-3)=1;