function [lkh probpairs means1 params1 A1 Pest1]=hsmmPlain(factors,conds,markers,Ah,means,params,maxlength,thresh)
nsubstates=size(params,1);
values = factors(:,2:end);
vector=repmat([1 2 3 0],1,nsubstates/3);
M=length(vector);
PAI=zeros(M,1);
nvals = size(values,2);
trials = factors(:,1);
x=find(trials==1);
nconds=max(conds);
ncases=length(x);
if length(x)>1
    y=cat(1,x(2:end)-1,length(trials));
else
    y =length(trials);
end
[B basetot] = constructProbs(values,means);
B = B';
T=size(B,2);               %The total time
D=maxlength;                %The maximum duration of states
                %The total number of observation values
%----------------------------------------------------
bmx=zeros(M,T);
S=zeros(M,T);
E=zeros(M,T);
PestC=zeros(M,D,nconds);
Best=zeros(M,T);
Qest=zeros(T,1);
GAMMAall=zeros(M,1);
if isempty(params)
    params=ones(9,2,nconds);
    params(:,2,:)=reshape(template',9,1,21);
end
P=zeros(M,maxlength,nconds);
temp=zeros(nsubstates,maxlength,nconds);
for i = 1:nsubstates
    for j = 1:nconds
        temp(i,:,j)=gammaCDM(params(i,1,j),params(i,2,j),maxlength)';
    end
end
P(vector>0,:,:)=temp;
P(vector==0,1,:)=1;
if thresh == 0
    bound = 1;
else
    bound = 100;
end

for ir=1:bound
%++++++++++++++++++     Forward     +++++++++++++++++
%---------------    Initialization    ---------------
    lkh=0;
    scans=1;
    Best(:)=0;
    PestC(:)=0;
    GAMMAall(:)=0;    
    for g = 1:ncases
        cond=conds(g);
        A = skips(Ah,params(:,:,cond),maxlength);
        PAI(1:3)=A(4,1:3)/sum(A(4,1:3));
        ALPHA=repmat(PAI,1,D).*P(:,:,cond);		%Equation (13)
        r=(B(:,scans)'*sum(ALPHA,2));			%Equation (3)
        bmx(:,scans)=B(:,scans)./r;		%Equation (2)
        E(:,scans)=bmx(:,scans).*ALPHA(:,1);	%Equation (5)
        S(:,scans)=A'*E(:,scans);			%Equation (6)
        lkh=lkh+log(r);
        scans=scans+1;
        %---------------    Induction    ---------------
        for t=2:trials(y(g))
            ALPHA=[repmat(S(:,scans-1),1,D-1).*P(:,1:D-1,cond)+repmat(bmx(:,scans-1),1,D-1).*ALPHA(:,2:D),S(:,scans-1).*P(:,D,cond)];		%Equation (12)
            r=(B(:,scans)'*sum(ALPHA,2));		%Equation (3)
            bmx(:,scans)=B(:,scans)./r;			%Equation (2)
            E(:,scans)=bmx(:,scans).*ALPHA(:,1);		%Equation (5)
            S(:,scans)=A'*E(:,scans);
            %Equation (6)
            lkh=lkh+log(r);
            scans=scans+1;
        end
        GAMMA=bmx(:,scans-1).*sum(ALPHA,2);
        Best(:,scans-1)=GAMMA;
        [X,Qest(scans-1)]=max(GAMMA);

        BETA=repmat(bmx(:,scans-1),1,D);				%Equation (7)
        Ex=sum(P(:,:,cond).*BETA,2);					%Equation (8)
        Sx=A*Ex;						%Equation (9)


    %---------------    Induction    ---------------
        for t=scans-2:-1:scans-trials(y(g))

            PestC(:,:,cond)=PestC(:,:,cond)+repmat(S(:,t),1,D).*BETA;
            %% for estimate of state at time t
            GAMMA=GAMMA+E(:,t).*Sx-S(:,t).*Ex;
            GAMMA(GAMMA<0)=0;           % eleminate errors due to inaccurace of the computation.
            [X,Qest(t)]=max(GAMMA);
            %% for estimate of B
            Best(:,t)=Best(:,t)+GAMMA;

            BETA=repmat(bmx(:,t),1,D).*[Sx,BETA(:,1:D-1)];	%Equation (14)
            Ex=sum(P(:,:,cond).*BETA,2);					%Equation (8)
            Sx=A*Ex;						%Equation (9)
        end
        GAMMAall=GAMMA+GAMMAall;
        PestC(:,:,cond)=PestC(:,:,cond)+repmat(PAI,1,D).*BETA;    
    end
    %++++++++ To check if the likelihood is increased ++++++++
    %basetot+lkh
        if ir>1
            basetot+lkh-basetot1-lkh1
        end
        if ir > 1 && (basetot+lkh-basetot1-lkh1)<thresh  
            break
        elseif isnan(lkh)
            break
        elseif thresh == 0
            lkh1 = lkh;
            probpairs=Best';
            basetot1=basetot;
            break
        else
            lkh1 = lkh;
            basetot1=basetot;
            params1=params;
            means1=means;
            probpairs=Best';
            A1=Ah;
            Pest1=PestC.*P;
        end
if thresh>0            % re-estimate parameters
    Ah=estimateA(probpairs,markers);
    PestC=PestC.*P; 
    E1 = Best;
    subvector=vector(vector>0);
    for i = 1:3
        weights =repmat(sum(E1(vector==i,:),1),nvals-1,1)';
        means(:,subvector==i)=repmat(sum(values(:,1:end-1).*weights)./sum(weights),sum(subvector==i),1)';
    end
    paramsx=estimateParams(PestC);
    temp=zeros(nsubstates,maxlength);
    for i = 1:nsubstates
            for j = 1:nconds
                %if min(paramsx(i,:,j)) > .001 
                    params(i,:)=paramsx(i,:);
                %end
                temp(i,:,j)=gammaCDM(params(i,1,j),params(i,2,j),maxlength)';
            end
    end
    P(vector>0,:,:)=temp;
    P(vector==0,1,:)=1;
    [B basetot] = constructProbs(values,means);
    B = B';
  end 
end
%[ir (lkh-lkh1)]
lkh=basetot1+lkh1;