function [val probs] = stateProb(states,params)
if max(params)>= 1 || min(params) <=0
    val = Inf;
else
    [ntrials nstates]=size(states);
    probs=zeros(ntrials,nstates);
    probs(:,1)=(1-params(:,1)).^[0:ntrials-1];
    for j = 2:nstates-1
        for i = j:36
            probs(i,j)=probs(i-1,j)*(1-params(j))+probs(i-1,j-1)*params(j-1);
        end
    end
    probs(:,nstates)=1-sum(probs,2);
    logprobs=log(probs);
    for j=2:nstates
        logprobs(logprobs(:,j)==-Inf,j)=0;
    end
    val=-sum(sum(states.*logprobs));
end

